﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private Socket client;
        private byte[] buffer = new byte[256];
        public delegate void DelegateSetText(string text);
        public delegate void DelegateSetButtons(bool connectbt, bool sendbt, bool disconnectbt);


        public Form1()
        {
            InitializeComponent();
        }
        //---------------------------------------------------------------------------------------


        private void bt_connect_Click(object sender, EventArgs e)
        {                   
            try
            {
                if ((tb_ip.Text != "") && (tb_port.Text != ""))
                {
                    client = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                    IPEndPoint ipep = new IPEndPoint(IPAddress.Parse(tb_ip.Text), int.Parse(tb_port.Text));
                    client.BeginConnect(ipep, new AsyncCallback(connectCallback), client);
                    bt_connect.Enabled = false;
                }
                else
                    sb_status.Text = "IP and Port needed!";
            }
            catch (SocketException)
            { sb_status.Text = "Connection not possible!"; }
        }
        //---------------------------------------------------------------------------------------


        private void connectCallback(IAsyncResult ar)
        {
            try
            {
                client = (Socket)ar.AsyncState;
                client.EndConnect(ar);
                sb_status.Text = "Connected!";
                SetButtons(false, true, true);
                client.BeginReceive(buffer, 0, 255, SocketFlags.None, new AsyncCallback(receiveCallback), client);
            }
            catch (Exception)
            { disconnect(); sb_status.Text = "Error while connecting!"; }
        }
        //---------------------------------------------------------------------------------------


        private void sendCallback(IAsyncResult ar)
        {
            try
            {
                Socket tmp_client = (Socket)ar.AsyncState;
                int bytessend = tmp_client.EndSend(ar);
            }
            catch (Exception)
            { sb_status.Text = "Error while sending"; }
        }
        //---------------------------------------------------------------------------------------

        
        private void receiveCallback(IAsyncResult ar)
        {
            string receivetext;
            int bytesRead;
            try
            {
                bytesRead = client.EndReceive(ar);
                receivetext = string.Empty;
                receivetext = Encoding.ASCII.GetString(buffer);
                SetText(receivetext);
                client.BeginReceive(buffer, 0, 255, SocketFlags.None, new AsyncCallback(receiveCallback), client);
            }
            catch (Exception)
            { bytesRead = 0; }

            if (bytesRead == 0 && client.Connected)
            {  disconnect();
            }
        }
        //---------------------------------------------------------------------------------------


        private void disconnect()
        {
            try
            {
                SetButtons(true, false, false);
                client.Shutdown(SocketShutdown.Both);
                client.Close();
                sb_status.Text = "not connected";
            }
            catch (Exception)
            { sb_status.Text = "Not able to disconnect"; }
        }
        //---------------------------------------------------------------------------------------


        private void bt_send_Click(object sender, EventArgs e)
        {
            byte[] byteData;
            if (cb_CRLF.Checked)
            {
                byteData = Encoding.ASCII.GetBytes(tb_send.Text + (char)13 + (char)10);
            }
            else
            {
                byteData = Encoding.ASCII.GetBytes(tb_send.Text);
            }
            client.BeginSend(byteData, 0, byteData.Length, 0, new AsyncCallback(sendCallback), client);
        }
        //---------------------------------------------------------------------------------------


        private void SetText(string receivetext)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new DelegateSetText(SetText), receivetext);
            }
            else
            {
                tb_receive.Text += receivetext;
            }
        }
        //---------------------------------------------------------------------------------------


        private void SetButtons(bool connectbt, bool sendbt, bool disconnectbt)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new DelegateSetButtons(SetButtons), connectbt, sendbt, disconnectbt);
            }
            else
            {
                bt_connect.Enabled = connectbt;
                bt_send.Enabled = sendbt;
                bt_disconnect.Enabled = disconnectbt;
            }
        }
        //---------------------------------------------------------------------------------------


        private void bt_disconnect_Click(object sender, EventArgs e)
        {
            disconnect(); 
        }
        //---------------------------------------------------------------------------------------


    }
}
